import prog1graphics.ApplicationBase;
import prog1graphics.Image;
import static prog1graphics.Graphics.*;

// Windows: ;
// Mac:     :
// javac -cp .:prog1javalib.jar StopWatch.java
// java -cp .:prog1javalib.jar StopWatch

public class StopWatch extends javafx.application.Application {
	
	private double time;

	public StopWatch() {
	}

	@Override
	public void start(javafx.stage.Stage stage) throws Exception {
		ApplicationBase.start("Stop Watch", 200, 200, stage, this::onDraw);
		ApplicationBase.setOnTick(this::onTick); // register tick function
	}

	private Image onDraw() {
		Image clock;
		clock = circle(75, pen("black", 3));
		for(int i=0;i<60;i++){
			clock = overlay(rotate(-i*6, above(rectangle(2, 5, "black"), rectangle(2, 150-5, "transparent"))), clock);
		}
		for(int i=0;i<12;i++){
			clock = overlay(rotate(-i*30, above(rectangle(4, 15, "black"), rectangle(4, 150-15, "transparent"))), clock);
		}
		int zone=Integer.parseInt(String.format("%tz",(long)time*1000))/100;
		clock = overlay(rotate(-time*360/60, above(rectangle(2, 90, "red"), rectangle(2, 30, "transparent"))), clock);
		clock = overlay(rotate(-time*360/60/60, above(rectangle(3, 60, "black"), rectangle(3, 60, "transparent"))), clock);
		clock = overlay(rotate(-time*360/60/60/12-zone*360/12, above(rectangle(4, 45, "black"), rectangle(4, 45, "transparent"))), clock);
		clock = overlay(circle(2, pen("black",3)), clock);
		clock = overlay(0, -25, text(String.format("%tT",(long)time*1000),25,"black"), clock);
		clock = overlay(clock, rectangle(200, 200, "transparent"));
		return clock;
	}

	private void onTick(double time) { // time in seconds
		this.time = System.currentTimeMillis()/1000;
	}
}
